#include "chdecl.h"
void CH_justify(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto c21;
    case 4: goto c38;
    case 5: goto c41;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* noop */
  
/* ige . 3.1 =(0) , 10 */
  if ( REF(3)DOT(1).value.integer >= 0 ) goto c10;
/* inegate 4 3.1 */
  REF(4).value.integer = -REF(3)DOT(1).value.integer;
  REF(4).tsdr = & dr_integer;
/* boolean 5 , FALSE */
  REF(5).value.boolean = FALSE;
  REF(5).tsdr = & dr_boolean;
/* branch , 13 */
   goto c13;
c10:
/* copy 4 3.1 */
  REF(4) = REF(3)DOT(1);
/* boolean 5 , TRUE */
  REF(5).value.boolean = TRUE;
  REF(5).tsdr = & dr_boolean;
c13:
/* size 6 3.0 */
  REF(6).value.integer = REF(3)DOT(0).value.table->size;
  REF(6).tsdr = & dr_integer;
/* ige . 4 6 , 18 */
  if ( REF(4).value.integer >= REF(6).value.integer ) goto c18;
/* copy 3.2 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(3)DOT(2).tsdr)->finalize)(REF(3)DOT(2).value,F_DISCARD,sched);
  REF(3)DOT(2).value = ch_val;
  REF(3)DOT(2).tsdr = & dr_table;
/* branch , 38 */
   goto c38;
c18:
/* new_table 3.2 , 1 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(2),QUAL(1),sched)) != Normal) 
     goto ch_raise_exception;
/* ilit 7 , 0 */
  REF(7).value.integer = 0;
  REF(7).tsdr = & dr_integer;
c21:
/* size 8 3.0 */
  REF(8).value.integer = REF(3)DOT(0).value.table->size;
  REF(8).tsdr = & dr_integer;
/* isubtract 9 4 8 */
  if (!chf_isubtract(DEF(9),REF(4).value.integer,REF(8).value.integer))
     goto ch_depletion;
/* ige . 7 9 , 31 */
  if ( REF(7).value.integer >= REF(9).value.integer ) goto c31;
/* ordenum_lit 10 , 32 */
  REF(10).value.ord_enum = 32;
  REF(10).tsdr = & dr_ord_enumeration;
/* insert 3.2 10 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(10),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* iadd 7 7 =(1) */
  if (!chf_iadd(DEF(7),REF(7).value.integer,1)) goto ch_depletion;
/* branch , 21 */
   goto c21;
c31:
/* branch_false 5 , 35 */
  if ( !REF(5).value.boolean ) goto c35;
/* copy 11 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val;
  REF(11).tsdr = & dr_table;
/* merge 3.2 11 */
  if ((ch_returncode = mergefunc(DEF(3)DOT(2),DEF(11),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 38 */
   goto c38;
c35:
/* copy 12 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).value = ch_val;
  REF(12).tsdr = & dr_table;
/* merge_at 3.2 12 =(0) */
  if ((ch_returncode = mergefunc(DEF(3)DOT(2),DEF(12),TRUE, 0)) != Normal)
     goto ch_raise_exception;
c38:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c41:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
